searchNodes=[{"doc":"Store the raw body for verification purposes. Use as Plug.Parsers :body_reader option in endpoint pipeline. After: https://hexdocs.pm/plug/Plug.Parsers.html#module-custom-body-reader","ref":"PhoenixApiToolkit.CacheBodyReader.html","title":"PhoenixApiToolkit.CacheBodyReader","type":"module"},{"doc":"Read the request body and cache the raw version in the conn. The raw version can be accessed with get_raw_request_body/1 . Examples use Plug.Test import PhoenixApiToolkit.CacheBodyReader import PhoenixApiToolkit.TestHelpers # the body is read and cached iex&gt; { :ok , raw_body , conn } = conn ( :get , &quot;/hello&quot; ) |&gt; put_raw_body ( &quot;some rawness&quot; ) |&gt; cache_and_read_body ( ) iex&gt; raw_body &quot;some rawness&quot; iex&gt; conn . assigns [ :raw_body ] [ &quot;some rawness&quot; ] # Plug.Conn.read_body/2 is used in the background, opts and responses responses are passed through iex&gt; result = conn ( :get , &quot;/hello&quot; ) |&gt; put_raw_body ( &quot;some rawness&quot; ) |&gt; cache_and_read_body ( length : 1 ) iex&gt; result |&gt; elem ( 0 ) :more","ref":"PhoenixApiToolkit.CacheBodyReader.html#cache_and_read_body/2","title":"PhoenixApiToolkit.CacheBodyReader.cache_and_read_body/2","type":"function"},{"doc":"Return the raw request body, after it is cached in the conn by cache_and_read_body/2 . Note that the raw request body is not a string! Examples use Plug.Test import PhoenixApiToolkit.CacheBodyReader import PhoenixApiToolkit.TestHelpers iex&gt; { :ok , _ , conn } = conn ( :get , &quot;/hello&quot; ) |&gt; put_raw_body ( &quot;the rawness&quot; ) |&gt; cache_and_read_body ( ) iex&gt; raw_body = conn |&gt; get_raw_request_body ( ) [ &quot;the rawness&quot; ] iex&gt; is_binary ( raw_body ) false iex&gt; to_string ( raw_body ) &quot;the rawness&quot;","ref":"PhoenixApiToolkit.CacheBodyReader.html#get_raw_request_body/1","title":"PhoenixApiToolkit.CacheBodyReader.get_raw_request_body/1","type":"function"},{"doc":"Dynamic filtering of Ecto queries is useful for creating list/index functions, and ultimately list/index endpoints, that accept a map of filters to apply to the query. Such a map can be based on HTTP query parameters, naturally. Several filtering types are so common that they have been implemented using standard filter macro's. This way, you only have to define which fields are filterable in what way. Documentation for such filters can be autogenerated using generate_filter_docs/2 . Example without standard filters import Ecto.Query require Ecto.Query def list_without_standard_filters ( filters \\\\ %{ } ) do from ( user in &quot;users&quot; , as : :user ) |&gt; apply_filters ( filters , fn { :order_by , { field , direction } } , query -&gt; order_by ( query , [ user : user ] , [ { ^ direction , field ( user , ^ field ) } ] ) { filter , value } , query when filter in [ :id , :name , :residence , :address ] -&gt; where ( query , [ user : user ] , field ( user , ^ filter ) == ^ value ) _ , query -&gt; query end ) end # filtering is optional iex&gt; list_without_standard_filters ( ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user &gt; # multiple equal_to matches can be combined iex&gt; list_without_standard_filters ( %{ residence : &quot;New York&quot; , address : &quot;Main Street&quot; } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : u0 . address == ^ &quot;Main Street&quot; , where : u0 . residence == ^ &quot;New York&quot; &gt; # equal_to matches and sorting can be combined iex&gt; list_without_standard_filters ( %{ residence : &quot;New York&quot; , order_by : { :name , :desc } } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : u0 . residence == ^ &quot;New York&quot; , order_by : [ desc : u0 . name ] &gt; # other fields are ignored / passed through iex&gt; list_without_standard_filters ( %{ number_of_arms : 3 } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user &gt; Example with standard filters and autogenerated docs Standard filters can be applied using the standard_filters/4 macro. It supports various filtering styles: equal_to matches, set membership, smaller/greater than comparisons, ordering and pagination. These filters must be configured at compile time. Standard filters can be combined with non-standard custom filters. Documentation can be autogenerated. @filter_definitions [ atom_keys : true , string_keys : true , limit : true , offset : true , order_by : true , order_by_aliases : [ role_name : { :role , :name } , username_last_letter : &amp; __MODULE__ . order_by_username_last_letter / 2 ] , equal_to : [ :id , :username , :address , :balance , role_name : { :role , :name } ] , equal_to_any : [ :address ] , string_starts_with : [ username_prefix : { :user , :username } ] , string_contains : [ username_search : :username ] , list_contains : [ :roles ] , list_contains_any : [ :roles ] , list_contains_all : [ all_roles : :roles ] , smaller_than : [ inserted_before : :inserted_at , balance_lt : :balance , role_inserted_before : { :role , :inserted_at } ] , greater_than_or_equal_to : [ inserted_at_or_after : :inserted_at , balance_gte : :balance ] ] @doc &quot;&quot;&quot; Custom filter function &quot;&quot;&quot; def by_group_name ( query , group_name ) do where ( query , [ user : user ] , user . group_name == ^ group_name ) end @doc &quot;&quot;&quot; Custom order_by handler &quot;&quot;&quot; def order_by_username_last_letter ( query , direction ) do order_by ( query , [ user : user ] , [ { ^ direction , fragment ( &quot;right(?, 1)&quot; , user . username ) } ] ) end @doc &quot;&quot;&quot; Function to resolve named bindings by dynamically joining them into the query. &quot;&quot;&quot; def resolve_binding ( query , named_binding ) do if has_named_binding? ( query , named_binding ) do query else case named_binding do :role -&gt; join ( query , :left , [ user : user ] , role in &quot;roles&quot; , as : :role ) _ -&gt; query end end end @doc &quot;&quot;&quot; My awesome list function. You can filter it, you know! And we guarantee the docs are up-to-date! \#{ generate_filter_docs ( @filter_definitions , equal_to : [ :group_name ] ) } &quot;&quot;&quot; def list_with_standard_filters ( filters \\\\ %{ } ) do from ( user in &quot;users&quot; , as : :user ) |&gt; apply_filters ( filters , fn # Add custom filters first and fallback to standard filters { :group_name , value } , query -&gt; by_group_name ( query , value ) filter , query -&gt; standard_filters ( query , filter , :user , @filter_definitions , &amp; resolve_binding / 2 ) end ) end # filtering is optional iex&gt; list_with_standard_filters ( ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user &gt; # let&#39;s do some filtering iex&gt; list_with_standard_filters ( %{ username : &quot;Peter&quot; , balance_lt : 50.00 , address : &quot;sesame street&quot; } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : u0 . address == ^ &quot;sesame street&quot; , where : u0 . balance &lt; ^ 50.0 , where : u0 . username == ^ &quot;Peter&quot; &gt; # associations can be dynamically joined into the query, only when necessary iex&gt; list_with_standard_filters ( %{ role_name : &quot;admin&quot; } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , left_join : r1 in &quot;roles&quot; , as : :role , on : true , where : r1 . name == ^ &quot;admin&quot; &gt; # limit, offset, and order_by are supported iex&gt; list_with_standard_filters ( %{ &quot;limit&quot; =&gt; 10 , offset : 1 , order_by : [ desc : :address ] } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , order_by : [ desc : u0 . address ] , limit : ^ 10 , offset : ^ 1 &gt; # order_by can use association fields as well, which are dynamically joined in that case iex&gt; list_with_standard_filters ( %{ order_by : [ asc : { :role , :name } ] } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , left_join : r1 in &quot;roles&quot; , as : :role , on : true , order_by : [ asc : r1 . name ] &gt; # order_by can use aliases defined in `order_by_aliases`, without breaking dynamic joining iex&gt; list_with_standard_filters ( %{ order_by : [ asc : :role_name ] } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , left_join : r1 in &quot;roles&quot; , as : :role , on : true , order_by : [ asc : r1 . name ] &gt; # order_by can use function aliases iex&gt; list_with_standard_filters ( %{ order_by : [ desc : :username_last_letter ] } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , order_by : [ desc : fragment ( &quot;right(?, 1)&quot; , u0 . username ) ] &gt; # complex custom filters can be combined with the standard filters iex&gt; list_with_standard_filters ( %{ group_name : &quot;admins&quot; , balance_gte : 50.00 } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : u0 . balance &gt; = ^ 50.0 , where : u0 . group_name == ^ &quot;admins&quot; &gt; # unsupported filters raise, but nonexistent order_by fields do not (although Ecto will raise, naturally) iex&gt; list_with_standard_filters ( %{ number_of_arms : 3 } ) ** (CaseClauseError) no case clause matching: {:number_of_arms, 3} iex&gt; list_with_standard_filters ( %{ order_by : [ :number_of_arms ] } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , order_by : [ asc : u0 . number_of_arms ] &gt; # filtering on lists of values, string prefixes and string-contains filters iex&gt; list_with_standard_filters ( %{ address : [ &quot;sesame street&quot; ] , username_prefix : &quot;foo&quot; , username_search : &quot;bar&quot; } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : u0 . address in ^ [ &quot;sesame street&quot; ] , where : ilike ( u0 . username , ^ &quot;foo%&quot; ) , where : ilike ( u0 . username , ^ &quot;%bar%&quot; ) &gt; # filtering on array-type fields iex&gt; list_with_standard_filters ( %{ roles : &quot;admin&quot; } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : fragment ( &quot;? &amp;&amp; ?&quot; , u0 . roles , ^ [ &quot;admin&quot; ] ) &gt; iex&gt; list_with_standard_filters ( %{ roles : [ &quot;admin&quot; , &quot;superadmin&quot; ] , all_roles : [ &quot;creator&quot; , &quot;user&quot; ] } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : fragment ( &quot;? @&gt; ?&quot; , u0 . roles , ^ [ &quot;creator&quot; , &quot;user&quot; ] ) , where : fragment ( &quot;? &amp;&amp; ?&quot; , u0 . roles , ^ [ &quot;admin&quot; , &quot;superadmin&quot; ] ) &gt; # you can order by multiple fields and specify bindings iex&gt; list_with_standard_filters ( %{ &quot;balance&quot; =&gt; 12 , &quot;order_by&quot; =&gt; [ asc : { :user , :username } , desc : :role ] } ) # Ecto.Query &lt; from u0 in &quot;users&quot; , as : :user , where : u0 . balance == ^ 12 , order_by : [ asc : u0 . username ] , order_by : [ desc : u0 . role ] &gt; Note that the aim is not to emulate GraphQL in a REST API. It is not possible for the API client to specify which fields the API should return or how deep the nesting should be: it is still necessary to develop different REST resources for differently-shaped responses (for example, /api/users or /api/users_with_groups etc). In a REST API, simple filtering and sorting functionality can be supported, however, without going the full GraphQL route. We will not discuss the pro's and cons of GraphQL versus REST here, but we maintain that GraphQL is not a drop-in replacement for REST API's in every situation and there is still a place for (flexible) REST API's, for example when caching on anything other than the client itself is desired or when development simplicity trumps complete flexibility and the number of different clients is limited. Generating documentation The call to generate_filter_docs/2 for the filter definitions as defined above will generate the following (rendered) docs: Filter key types Filter keys may be both atoms and strings, e.g. %{username: &quot;Dave123&quot;, &quot;first_name&quot; =&gt; &quot;Dave&quot;} Equal-to filters The field's value must be equal to the filter value. The equivalent Ecto code is where ( query , [ binding : bd ] , bd . field == ^ filter_value ) The following filter names are supported: address balance group_name id role_name (actual field is role.name) username Equal-to-any filters The field's value must be equal to any of the filter values. The equivalent Ecto code is where ( query , [ binding : bd ] , bd . field in ^ filter_value ) The following filter names are supported: address Smaller-than filters The field's value must be smaller than the filter's value. The equivalent Ecto code is where ( query , [ binding : bd ] , bd . field &lt; ^ filter_value ) The following filter names are supported: Filter name Must be smaller than balance_lt balance inserted_before inserted_at role_inserted_before role.inserted_at Greater-than-or-equal-to filters The field's value must be greater than or equal to the filter's value. The equivalent Ecto code is where ( query , [ binding : bd ] , bd . field &gt;= ^ filter_value ) The following filter names are supported: Filter name Must be greater than or equal to balance_gte balance inserted_at_or_after inserted_at String-starts-with filters The string-type field's value must start with the filter's value. The equivalent Ecto code is where ( query , [ binding : bd ] , ilike ( bd . field , ^ ( val &lt;&gt; &quot;%&quot; ) ) ) The following filter names are supported: username_prefix (actual field is user.username) String-contains filters The string-type field's value must contain the filter's value. The equivalent Ecto code is where ( query , [ binding : bd ] , ilike ( bd . field , ^ ( &quot;%&quot; &lt;&gt; val &lt;&gt; &quot;%&quot; ) ) ) The following filter names are supported: username_search (actual field is username) List-contains filters The array-type field's value must contain the filter's value (set membership). The equivalent Ecto code is where ( query , [ binding : bd ] , fragment ( &quot;? &amp;&amp; ?&quot; , bd . field , ^ [ val ] ) ) The following filter names are supported: roles List-contains-any filters The array-type field's value must contain any of the filter's values (set intersection). The equivalent Ecto code is where ( query , [ binding : bd ] , fragment ( &quot;? &amp;&amp; ?&quot; , bd . field , ^ val ) ) The following filter names are supported: roles List-contains-all filters The array-type field's value must contain all of the filter's values (subset). The equivalent Ecto code is where ( query , [ binding : bd ] , fragment ( &quot;? @&gt; ?&quot; , bd . field , ^ val ) ) The following filter names are supported: all_roles (actual field is roles) Order-by sorting Order-by filters do not actually filter the result set, but sort it according to the filter's value(s). The supported directions can be found in the docs of Ecto.Query.order_by/3 . Order-by filters take a list argument, that can consist of the following elements: field will sort on the specified field of the default binding in ascending order {:direction, :field} will sort on the specified field of the default binding in the specified direction {:direction, {:binding, :field}} will sort on the specified field of the specified binding in the specified direction. Note that the value of order_by filters must consist of atoms, even with string_keys enabled. All fields present in the query on any named binding are supported. Additionally, aliases for fields in non-default bindings can be defined in order_by_aliases . The alias can then be used in order_by filters. The following aliases are supported: role_name (actual field is role.name ) username_last_letter (opague) Limit filter The limit filter sets a maximum for the number of rows in the result set and may be used for pagination. Offset filter The offset filter skips a number of rows in the result set and may be used for pagination.","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html","title":"PhoenixApiToolkit.Ecto.DynamicFilters","type":"module"},{"doc":"Applies filters to query by reducing filters using filter_reductor . Combine with the custom queries from Ecto.Query to write complex filterables. Several standard filters have been implemented in standard_filters/4 . See the module docs Elixir.PhoenixApiToolkit.Ecto.DynamicFilters for details and examples.","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#apply_filters/3","title":"PhoenixApiToolkit.Ecto.DynamicFilters.apply_filters/3","type":"function"},{"doc":"Generate a markdown docstring from filter definitions, as passed to standard_filters/4 , as defined by filter_definitions/0 . By specifying extras , documentation can be generated for any custom filters supported by your function as well. See the module docs Elixir.PhoenixApiToolkit.Ecto.DynamicFilters for details and examples.","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#generate_filter_docs/2","title":"PhoenixApiToolkit.Ecto.DynamicFilters.generate_filter_docs/2","type":"function"},{"doc":"Same as standard_filters/5 but does not support dynamically resolving named bindings.","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#standard_filters/4","title":"PhoenixApiToolkit.Ecto.DynamicFilters.standard_filters/4","type":"macro"},{"doc":"Applies standard filters to the query. Standard filters include filters for equal_to matches, set membership, smaller/greater than comparisons, ordering and pagination. See the module docs Elixir.PhoenixApiToolkit.Ecto.DynamicFilters for details and examples. Mandatory parameters: query : the Ecto query that is narrowed down filter : the current filter that is being applied to query default_binding : the named binding of the Ecto model that generic queries are applied to, unless specified otherwise filter_definitions : keyword list of filter types and the filter definitions for which they should be generated Optional parameters: resolve_binding: a function that can be passed in to dynamically join the query to resolve named bindings requested in filters The options supported by the filter_definitions parameter are: atom_keys : supports filter keys as atoms, e.g. %{username: &quot;Dave&quot;} string_keys : supports filter keys as strings, e.g. %{&quot;username&quot; =&gt; &quot;Dave&quot;} . Note that order_by VALUES must always be atoms: %{&quot;order_by&quot; =&gt; :username} will work but %{order_by: &quot;username&quot;} will not. limit : enables limit filter offset : enables offset filter order_by : enables order_by filter order_by_aliases : set an alias for a non-default-binding-field, e.g. {:role_name, {:role, :name}} which enables order_by: [desc: :role_name] OR provide an ordering function that takes the query and direction as arguments equal_to : field must be equal to filter. equal_to_any : field must be equal to any value of filter, e.g. user.id in [1, 2, 3] . Filter names can be the same as equal_to filters. smaller_than : field must be smaller than filter value, e.g. user.score &lt; value greater_than_or_equal_to : field must be greater than or equal to filter value, e.g. user.score &gt;= value string_starts_with : string field must start with case-insensitive string prefix, e.g. user.name starts with &quot;dav&quot; string_contains : string field must contain case-insensitive string, e.g. user.name contains &quot;av&quot; list_contains : array field must contain filter value, e.g. &quot;admin&quot; in user.roles (equivalent to set membership) list_contains_any : array field must contain any filter value, e.g. user.roles contains any of [&quot;admin&quot;, &quot;creator&quot;] (equivalent to set intersection). Filter names can be the same as list_contains filters. list_contains_all : array field must contain all filter values, e.g. user.roles contains all of [&quot;admin&quot;, &quot;creator&quot;] (equivalent to subset). Filter names can be the same as list_contains filters.","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#standard_filters/5","title":"PhoenixApiToolkit.Ecto.DynamicFilters.standard_filters/5","type":"macro"},{"doc":"Extra filters supported by a function, for which documentation should be generated by generate_filter_docs/2 . A keyword list of filter types and the fields for which documentation should be generated.","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#t:extra_filter_definitions/0","title":"PhoenixApiToolkit.Ecto.DynamicFilters.extra_filter_definitions/0","type":"type"},{"doc":"Format of a filter that can be applied to a query to narrow it down","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#t:filter/0","title":"PhoenixApiToolkit.Ecto.DynamicFilters.filter/0","type":"type"},{"doc":"Definition used to generate a filter for standard_filters/4 . May take the following forms: atom filter name and name of field of default binding {filter_name, actual_field} if the filter name is different from the name of the field of the default binding {filter_name, {binding, actual_field}} if the field is a field of another named binding","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#t:filter_definition/0","title":"PhoenixApiToolkit.Ecto.DynamicFilters.filter_definition/0","type":"type"},{"doc":"Filter definitions supported by standard_filters/4 . A keyword list of filter types and the filter definitions for which they should be generated.","ref":"PhoenixApiToolkit.Ecto.DynamicFilters.html#t:filter_definitions/0","title":"PhoenixApiToolkit.Ecto.DynamicFilters.filter_definitions/0","type":"type"},{"doc":"Generic validators and helper functions for validating Ecto changesets. Examples The examples in this module use the following basic schema and changeset: @schema %{ first_name : :string , last_name : :string , last_name_prefix : :string , order_by : :string , file : :string } def changeset ( changes \\\\ %{ } ) do { %{ } , @schema } |&gt; cast ( changes , [ :first_name , :last_name , :order_by , :file ] ) end","ref":"PhoenixApiToolkit.Ecto.Validators.html","title":"PhoenixApiToolkit.Ecto.Validators","type":"module"},{"doc":"If the changeset does not contain a change for field - even if the field already has a value in the changeset data - set it to change . Useful for setting default changes. Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . iex&gt; changeset ( ) |&gt; default_change ( :first_name , &quot;Peter&quot; ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Peter&quot; } , errors : [ ] , data : %{ } , valid? : true &gt; iex&gt; changeset ( %{ first_name : &quot;Jason&quot; } ) |&gt; default_change ( :first_name , &quot;Peter&quot; ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Jason&quot; } , errors : [ ] , data : %{ } , valid? : true &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#default_change/3","title":"PhoenixApiToolkit.Ecto.Validators.default_change/3","type":"function"},{"doc":"If changeset is valid, apply the first function then_do to it, else apply the second function else_do to it, which defaults to the identity function. Examples # function then_do is applied to the changeset if it is valid iex&gt; % Ecto.Changeset { valid? : true } |&gt; map_if_valid ( &amp; &amp;1 . changes ) %{ } # if the changeset is invalid and else_do is provided, apply it to the changeset iex&gt; % Ecto.Changeset { valid? : false } |&gt; map_if_valid ( &amp; &amp;1 . changes , &amp; &amp;1 . errors ) [ ] # else_do defaults to identity, returning the changeset iex&gt; % Ecto.Changeset { valid? : false } |&gt; map_if_valid ( &amp; &amp;1 . changes ) # Ecto.Changeset &lt; action : nil , changes : %{ } , errors : [ ] , data : nil , valid? : false &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#map_if_valid/3","title":"PhoenixApiToolkit.Ecto.Validators.map_if_valid/3","type":"function"},{"doc":"Move a change to another field in the changeset (if its value is not nil). Like Ecto.Changeset.put_change/3 , the change is moved without additional validation. Optionally, the value can be mapped using value_mapper , which defaults to the identity function. Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . # there is no effect when there is no change to the field iex&gt; changeset ( ) |&gt; move_change ( :first_name , :last_name ) # Ecto.Changeset &lt; action : nil , changes : %{ } , errors : [ ] , data : %{ } , valid? : true &gt; # a change is moved to another field name as-is by default iex&gt; changeset ( %{ first_name : &quot;Pan&quot; } ) |&gt; move_change ( :first_name , :last_name ) # Ecto.Changeset &lt; action : nil , changes : %{ last_name : &quot;Pan&quot; } , errors : [ ] , data : %{ } , valid? : true &gt; # an optional value_mapper can be passed to do some processing on the change along the way iex&gt; changeset ( %{ first_name : &quot;Pan&quot; } ) |&gt; move_change ( :first_name , :last_name , &amp; String . upcase ( &amp;1 ) ) # Ecto.Changeset &lt; action : nil , changes : %{ last_name : &quot;PAN&quot; } , errors : [ ] , data : %{ } , valid? : true &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#move_change/4","title":"PhoenixApiToolkit.Ecto.Validators.move_change/4","type":"function"},{"doc":"Apply function to multiple fields of the changeset. Convenience wrapper for validators that don't support multiple fields. Examples / doctests For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . iex&gt; changeset ( %{ first_name : &quot;Luke&quot; , last_name : &quot;Skywalker&quot; } ) ...&gt; |&gt; multifield_apply ( [ :first_name , :last_name ] , &amp; validate_length ( &amp;1 , &amp;2 , max : 3 ) ) ...&gt; |&gt; Map . take ( [ :valid? , :errors ] ) %{ valid? : false , errors : [ { :last_name , { &quot;should be at most %{count} character(s)&quot; , [ count : 3 , validation : :length , kind : :max , type : :string ] } } , { :first_name , { &quot;should be at most %{count} character(s)&quot; , [ count : 3 , validation : :length , kind : :max , type : :string ] } } ] }","ref":"PhoenixApiToolkit.Ecto.Validators.html#multifield_apply/3","title":"PhoenixApiToolkit.Ecto.Validators.multifield_apply/3","type":"function"},{"doc":"If the changeset does not contain a change for field - even if the field already has a value in the changeset data - set it to change . Useful for setting default changes. Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . iex&gt; changeset ( ) |&gt; put_change_if_unchanged ( :first_name , &quot;Peter&quot; ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Peter&quot; } , errors : [ ] , data : %{ } , valid? : true &gt; iex&gt; changeset ( %{ first_name : &quot;Jason&quot; } ) |&gt; put_change_if_unchanged ( :first_name , &quot;Peter&quot; ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Jason&quot; } , errors : [ ] , data : %{ } , valid? : true &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#put_change_if_unchanged/3","title":"PhoenixApiToolkit.Ecto.Validators.put_change_if_unchanged/3","type":"function"},{"doc":"Validates that field is a suitable parameter for an (i)like query. User input for (i)like queries should not contain metacharacters because this creates a denial-of-service attack vector: introducing a lot of metacharacters rapidly increases the performance costs of such queries. The metacharacters for (i)like queries are '_', '%' and the escape character of the database, which defaults to '\\'. Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . iex&gt; changeset ( %{ first_name : &quot;Peter&quot; , last_name : &quot;Pan&quot; } ) |&gt; validate_ilike_safe ( [ :first_name , :last_name ] ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Peter&quot; , last_name : &quot;Pan&quot; } , errors : [ ] , data : %{ } , valid? : true &gt; iex&gt; changeset ( %{ first_name : &quot;Peter%&quot; } ) |&gt; validate_ilike_safe ( :first_name ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Peter%&quot; } , errors : [ first_name : { &quot;may not contain _ % or \\\\ &quot; , [ validation : :format ] } ] , data : %{ } , valid? : false &gt; iex&gt; changeset ( %{ first_name : &quot;Pet_er&quot; } ) |&gt; validate_ilike_safe ( :first_name ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Pet_er&quot; } , errors : [ first_name : { &quot;may not contain _ % or \\\\ &quot; , [ validation : :format ] } ] , data : %{ } , valid? : false &gt; iex&gt; changeset ( %{ first_name : &quot;Pet \\\\ er&quot; } ) |&gt; validate_ilike_safe ( :first_name ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Pet \\\\ er&quot; } , errors : [ first_name : { &quot;may not contain _ % or \\\\ &quot; , [ validation : :format ] } ] , data : %{ } , valid? : false &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#validate_ilike_safe/2","title":"PhoenixApiToolkit.Ecto.Validators.validate_ilike_safe/2","type":"function"},{"doc":"Validate the value of an order_by query parameter. The format of the parameter is expected to match ~r/^(asc|desc|asc_nulls_last|desc_nulls_last|asc_nulls_first|desc_nulls_first):(\\w{1,20})$/ (may be repeated, comma-separated). The supported fields should be passed as a list or MapSet (which performs better) to orderables . If the change is valid, the original change is replaced with a keyword list of {:field, :direction} , which is supported by PhoenixApiToolkit.Ecto.DynamicFilters.standard_filters/4 . Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . @orderables ~w(first_name last_name) |&gt; MapSet . new ( ) iex&gt; changeset ( %{ order_by : &quot;asc:last_name&quot; } ) |&gt; validate_order_by ( @orderables ) # Ecto.Changeset &lt; action : nil , changes : %{ order_by : [ asc : :last_name ] } , errors : [ ] , data : %{ } , valid? : true &gt; iex&gt; changeset ( %{ order_by : &quot;invalid&quot; } ) |&gt; validate_order_by ( @orderables ) # Ecto.Changeset &lt; action : nil , changes : %{ order_by : [ ] } , errors : [ order_by : { &quot;format is asc|desc:field&quot; , [ ] } ] , data : %{ } , valid? : false &gt; iex&gt; changeset ( %{ order_by : &quot;asc:eye_count&quot; } ) |&gt; validate_order_by ( @orderables ) # Ecto.Changeset &lt; action : nil , changes : %{ order_by : [ ] } , errors : [ order_by : { &quot;unknown field eye_count&quot; , [ ] } ] , data : %{ } , valid? : false &gt; iex&gt; changeset ( %{ order_by : nil } ) |&gt; validate_order_by ( @orderables ) # Ecto.Changeset &lt; action : nil , changes : %{ } , errors : [ ] , data : %{ } , valid? : true &gt; iex&gt; changeset ( %{ order_by : &quot;asc:last_name,desc_nulls_last:first_name&quot; } ) |&gt; validate_order_by ( @orderables ) # Ecto.Changeset &lt; action : nil , changes : %{ order_by : [ asc : :last_name , desc_nulls_last : :first_name ] } , errors : [ ] , data : %{ } , valid? : true &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#validate_order_by/2","title":"PhoenixApiToolkit.Ecto.Validators.validate_order_by/2","type":"function"},{"doc":"Validates that field (or multiple fields) contains plaintext. Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . iex&gt; changeset ( %{ first_name : &quot;Peter&quot; , last_name : &quot;Pan&quot; } ) |&gt; validate_plaintext ( [ :first_name , :last_name ] ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Peter&quot; , last_name : &quot;Pan&quot; } , errors : [ ] , data : %{ } , valid? : true &gt; iex&gt; changeset ( %{ first_name : &quot;Peter{}&quot; } ) |&gt; validate_plaintext ( :first_name ) # Ecto.Changeset &lt; action : nil , changes : %{ first_name : &quot;Peter{}&quot; } , errors : [ first_name : { &quot;can only contain a-Z 0-9 _ . , - ! ? and whitespace&quot; , [ validation : :format ] } ] , data : %{ } , valid? : false &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#validate_plaintext/2","title":"PhoenixApiToolkit.Ecto.Validators.validate_plaintext/2","type":"function"},{"doc":"Validate a searchable field. If the value of field is postfixed with '*', a fuzzy search instead of a equal_to match is considered to be intended. In this case, the value must be at least 4 characters long and must be (i)like safe (as per validate_ilike_safe/2 ), and is moved to search_field . The postfix '*' is stripped from the search string. The purpose is to pass the changes along to a list -query which supports searching by search_field , and equal_to filtering by field . See PhoenixApiToolkit.Ecto.DynamicFilters for more info on dynamic filtering. The minimum length for a search string can be overridden with option :min_length . Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . # a last_name value postfixed with &#39;*&#39; is search query iex&gt; changeset ( %{ last_name : &quot;Smit*&quot; } ) |&gt; validate_searchable ( :last_name , :last_name_prefix ) # Ecto.Changeset &lt; action : nil , changes : %{ last_name_prefix : &quot;Smit&quot; } , errors : [ ] , data : %{ } , valid? : true &gt; # values without postfix &#39;*&#39; are passed through iex&gt; changeset ( %{ last_name : &quot;Smit&quot; } ) |&gt; validate_searchable ( :last_name , :last_name_prefix ) # Ecto.Changeset &lt; action : nil , changes : %{ last_name : &quot;Smit&quot; } , errors : [ ] , data : %{ } , valid? : true &gt; # to prevent too-broad, expensive ilike queries, search parameters must be &gt;=4 characters long iex&gt; changeset ( %{ last_name : &quot;Smi*&quot; } ) |&gt; validate_searchable ( :last_name , :last_name_prefix ) # Ecto.Changeset &lt; action : nil , changes : %{ last_name : &quot;Smi&quot; } , errors : [ last_name : { &quot;should be at least %{count} character(s)&quot; , [ count : 4 , validation : :length , kind : :min , type : :string ] } ] , data : %{ } , valid? : false &gt; # the min_length value can be overridden iex&gt; changeset ( %{ last_name : &quot;Smi*&quot; } ) |&gt; validate_searchable ( :last_name , :last_name_prefix , min_length : 5 ) # Ecto.Changeset &lt; action : nil , changes : %{ last_name : &quot;Smi&quot; } , errors : [ last_name : { &quot;should be at least %{count} character(s)&quot; , [ count : 5 , validation : :length , kind : :min , type : :string ] } ] , data : %{ } , valid? : false &gt; # additionally, search parameters must be ilike safe, as per validate_ilike_safe/2 iex&gt; changeset ( %{ last_name : &quot;Sm_it*&quot; } ) |&gt; validate_searchable ( :last_name , :last_name_prefix ) # Ecto.Changeset &lt; action : nil , changes : %{ last_name : &quot;Sm_it&quot; } , errors : [ last_name : { &quot;may not contain _ % or \\\\ &quot; , [ validation : :format ] } ] , data : %{ } , valid? : false &gt;","ref":"PhoenixApiToolkit.Ecto.Validators.html#validate_searchable/4","title":"PhoenixApiToolkit.Ecto.Validators.validate_searchable/4","type":"function"},{"doc":"For verifying files uploaded as base64-encoded binaries. Attempts to decode field and validate its file signature. The file signature, also known as a file's &quot;magic bytes&quot;, can be looked up on the internet (for example here ) and may be a list of allowed magic byte types. Examples For the implementation of changeset/1 , see Elixir.PhoenixApiToolkit.Ecto.Validators . @pdf_signature &quot;255044462D&quot; |&gt; Base . decode16! ( ) @png_signature &quot;89504E470D0A1A0A&quot; |&gt; Base . decode16! ( ) @png_file &quot;iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNk+A8AAQUBAScY42YAAAAASUVORK5CYII=&quot; @gif_file &quot;R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==&quot; # if the signature checks out, the uploaded file is decoded and the changeset valid iex&gt; cs = changeset ( %{ file : @png_file } ) |&gt; validate_upload ( :file , @png_signature ) iex&gt; { cs . valid? , cs . changes . file } { true , @png_file |&gt; Base . decode64! ( ) } # multiple signatures can be provided iex&gt; cs = changeset ( %{ file : @png_file } ) |&gt; validate_upload ( :file , [ @pdf_signature , @png_signature ] ) iex&gt; cs . valid? true # if the signature does not check out, an error is added to the changeset and the decoded file is discarded iex&gt; cs = changeset ( %{ file : @gif_file } ) |&gt; validate_upload ( :file , [ @pdf_signature , @png_signature ] ) iex&gt; { cs . valid? , cs . errors , cs . changes . file } { false , [ file : { &quot;invalid file type&quot; , [ ] } ] , @gif_file } # decoding errors are handled gracefully iex&gt; cs = changeset ( %{ file : &quot;a&quot; } ) |&gt; validate_upload ( :file , @pdf_signature ) iex&gt; { cs . valid? , cs . errors } { false , [ file : { &quot;invalid base64 encoding&quot; , [ ] } ] }","ref":"PhoenixApiToolkit.Ecto.Validators.html#validate_upload/3","title":"PhoenixApiToolkit.Ecto.Validators.validate_upload/3","type":"function"},{"doc":"Request validator for generic (REST) requests. Meant to supplement database-level Ecto changesets. For example when creating a new entity, your database contexts / changesets will do their own validations and it would be useless to do so an extra time. Suppose you have the following &quot;users&quot; resource: GET /api/users GET /api/users/{id} You could have the following resource request validator and controller. The users context is not present here, but if it uses PhoenixApiToolkit.Ecto.DynamicFilters the processed query parameters can be passed straight on and will result in a single filtered query. defmodule MyUsersRequestValidator do import Ecto.Changeset import PhoenixApiToolkit.Ecto.Validators import PhoenixApiToolkit.GenericRequestValidator @schema resource_schema ( %{ username : :string } , %{ date_of_birth : :date } ) @entity_fields @schema |&gt; get_entity_fields ( ) def index_query ( attrs ) do @schema |&gt; query_order_by ( attrs ) |&gt; query_pagination ( attrs ) |&gt; cast ( attrs , @entity_fields ) end end defmodule MyUsersController do use MyAppWeb , :controller import Plug.Conn alias MyUsersRequestValidator , as : ReqVal alias PhoenixApiToolkit.GenericRequestValidator , as : GenReqVal def index ( conn , _params ) do with %{ valid? : true , changes : query_params } &lt;- ReqVal . index_query ( conn . query_params ) , users &lt;- MyUsersContext . list ( query_params ) do conn |&gt; send_resp ( 200 , Jason . encode! ( users ) ) else _ -&gt; conn |&gt; send_resp ( 400 , &quot;idiot, your request is bad&quot; ) end end def show ( conn , _params ) do with { valid? : true , changes : %{ id : id } } &lt;- GenReqVal . path_param ( conn . path_params ) , user when not is_nil ( user ) &lt;- MyUsersContext . get ( id ) do conn |&gt; send_resp ( 200 , Jason . encode! ( user ) ) else _ -&gt; conn |&gt; send_resp ( 400 , &quot;idiot, your request is bad&quot; ) end end end","ref":"PhoenixApiToolkit.GenericRequestValidator.html","title":"PhoenixApiToolkit.GenericRequestValidator","type":"module"},{"doc":"Get all the &quot;non-meta&quot; fields from a schema, that is, fields [:limit, :offset, :order_by, :lock_version] are filtered out. Examples iex&gt; resource_schema ( %{ first_name : :string } ) |&gt; get_entity_fields ( ) [ :first_name , :id ]","ref":"PhoenixApiToolkit.GenericRequestValidator.html#get_entity_fields/1","title":"PhoenixApiToolkit.GenericRequestValidator.get_entity_fields/1","type":"function"},{"doc":"Validates the path parameter of a generic GET request of a RESTful resource. Examples # &quot;id&quot; is a required parameter iex&gt; path_param ( %{ } ) |&gt; Map . get ( :valid? ) false # &quot;id&quot; must be an integer iex&gt; path_param ( %{ &quot;id&quot; =&gt; &quot;boom&quot; } ) |&gt; Map . get ( :valid? ) false # &quot;id&quot; must be greater than 0 iex&gt; path_param ( %{ &quot;id&quot; =&gt; 0 } ) |&gt; Map . get ( :valid? ) false iex&gt; path_param ( %{ &quot;id&quot; =&gt; 1 } ) |&gt; Map . get ( :valid? ) true","ref":"PhoenixApiToolkit.GenericRequestValidator.html#path_param/1","title":"PhoenixApiToolkit.GenericRequestValidator.path_param/1","type":"function"},{"doc":"Validates the order_by query parameter of an index endpoint. Examples iex&gt; resource_schema ( ) |&gt; query_order_by ( %{ &quot;order_by&quot; =&gt; &quot;asc:last_name&quot; } , ~w(last_name) |&gt; MapSet . new ( ) ) # Ecto.Changeset &lt; action : nil , changes : %{ order_by : [ asc : :last_name ] } , errors : [ ] , data : %{ } , valid? : true &gt; See PhoenixApiToolkit.Ecto.Validators.validate_order_by/2 for more examples.","ref":"PhoenixApiToolkit.GenericRequestValidator.html#query_order_by/3","title":"PhoenixApiToolkit.GenericRequestValidator.query_order_by/3","type":"function"},{"doc":"Validates the limit and offset query parameters of an index endpoint. If max_limit == nil , no maximum limit is enforced. Examples # the requested limit and offset should be in the range 0 - max_limit iex&gt; resource_schema ( ) |&gt; query_pagination ( %{ &quot;limit&quot; =&gt; 10 } , 100 ) # Ecto.Changeset &lt; action : nil , changes : %{ limit : 10 } , errors : [ ] , data : %{ } , valid? : true &gt; iex&gt; cs = resource_schema ( ) |&gt; query_pagination ( %{ &quot;limit&quot; =&gt; 150 } , 100 ) iex&gt; cs . valid? false # a default limit can be set so that a default number of results is returned iex&gt; resource_schema ( ) |&gt; query_pagination ( %{ } , 100 , 50 ) # Ecto.Changeset &lt; action : nil , changes : %{ limit : 50 } , errors : [ ] , data : %{ } , valid? : true &gt; # no max limit is enforced if `max_limit == nil` iex&gt; resource_schema ( ) |&gt; query_pagination ( %{ &quot;limit&quot; =&gt; 1_000_000 } , nil ) # Ecto.Changeset &lt; action : nil , changes : %{ limit : 1000000 } , errors : [ ] , data : %{ } , valid? : true &gt; # default limit can be disabled iex&gt; resource_schema ( ) |&gt; query_pagination ( %{ } , nil , nil ) # Ecto.Changeset &lt; action : nil , changes : %{ } , errors : [ ] , data : %{ } , valid? : true &gt;","ref":"PhoenixApiToolkit.GenericRequestValidator.html#query_pagination/4","title":"PhoenixApiToolkit.GenericRequestValidator.query_pagination/4","type":"function"},{"doc":"Creates a generic schema for a REST resource. In general, REST resources will support an integer id as a path parameter, and the index endpoint will support order_by , limit and offset . Additionally, some endpoints will support a lock_version for optimistic locking using Ecto.Changeset.optimistic_lock/3 . Additional fields can be passed along to the extra_fields parameter. Fields that can (usefully) be compared with smaller than / greater than comparisons can be passed in comparables . The value you pass AND a &quot;_lt&quot; (smaller than) and &quot;_gte&quot; (greater than or equal to) variant will be added to the schema. Examples # the result can be fed to cast/3 iex&gt; resource_schema ( ) |&gt; Ecto.Changeset . cast ( %{ } , [ ] ) # Ecto.Changeset &lt; action : nil , changes : %{ } , errors : [ ] , data : %{ } , valid? : true &gt; # an extended schema can be created by providing a map of fields iex&gt; resource_schema ( %{ first_name : :string } ) { %{ } , %{ first_name : :string , id : :integer , limit : :integer , lock_version : :integer , offset : :integer , order_by : :string } } # fields passed to the &quot;comparables&quot; parameter are added literally AND with _lt and _gte variants iex&gt; resource_schema ( %{ } , %{ date_of_birth : :date } ) |&gt; elem ( 1 ) |&gt; Map . has_key? ( :date_of_birth_lt ) true","ref":"PhoenixApiToolkit.GenericRequestValidator.html#resource_schema/2","title":"PhoenixApiToolkit.GenericRequestValidator.resource_schema/2","type":"function"},{"doc":"A simple Ecto schema, embedded only, not coupled to a module or database entity","ref":"PhoenixApiToolkit.GenericRequestValidator.html#t:schema/0","title":"PhoenixApiToolkit.GenericRequestValidator.schema/0","type":"type"},{"doc":"Checks HMAC authentication. Expects a HMAC-&lt;some_algorithm&gt; of the request body to be present in the &quot;authorization&quot; header. Supported algorithms are those supported by :crypto.mac/4 . Relies on PhoenixApiToolkit.CacheBodyReader being called by Plug.Parsers . To be considered a valid request by the plug, a request has to meet the following criteria: the request path must match the &quot;path&quot; stated in the request body the request HTTP method must match the &quot;method&quot; stated in the request body the request &quot;timestamp&quot; must not be older than max_age If the token is invalid for any reason, PhoenixApiToolkit.Security.HmacVerificationError is raised, resulting in a 401 Unauthorized response. Configuration options hmac_secret as a binary (mandatory): the secret used to create the HMAC hash_algorithm as an atom (optional, defaults to :sha256 ) the hashing algorithm used to create the HMAC max_age in seconds (optional, defaults to 120 ) the maximum age of the request before it is considered invalid Request body format example { &quot;path&quot; : &quot;/api/v2/accounts&quot; , &quot;method&quot; : &quot;POST&quot; , &quot;timestamp&quot; : 1321321545 , &quot;contents&quot; : { &quot;key1&quot; : &quot;value1&quot; , &quot;something&quot; : &quot;else&quot; } } Examples use Plug.Test alias PhoenixApiToolkit.Security.HmacPlug import PhoenixApiToolkit.TestHelpers import PhoenixApiToolkit.CacheBodyReader @secret &quot;supersecretkey&quot; def opts , do : HmacPlug . init ( lazy_hmac_secret : fn -&gt; @secret end ) def conn_for_hmac ( method , path , raw_body ) do conn ( method , path , raw_body |&gt; Jason . decode! ( ) ) |&gt; application_json ( ) |&gt; put_raw_body ( raw_body ) end # a correctly signed request is passed through iex&gt; body = create_hmac_plug_body ( &quot;/&quot; , &quot;POST&quot; , %{ hello : &quot;world&quot; } ) iex&gt; { :ok , _raw_body , conn } = conn_for_hmac ( :post , &quot;/&quot; , body ) |&gt; put_hmac ( body , @secret ) |&gt; cache_and_read_body ( ) iex&gt; conn = HmacPlug . call ( conn , opts ( ) ) iex&gt; conn . body_params [ &quot;contents&quot; ] %{ &quot;hello&quot; =&gt; &quot;world&quot; } # requests that are noncompliant result in a PhoenixApiToolkit.Security.HmacVerificationError iex&gt; body = create_hmac_plug_body ( &quot;/&quot; , &quot;PUT&quot; , %{ hello : &quot;world&quot; } ) iex&gt; { :ok , _raw_body , conn } = conn_for_hmac ( :post , &quot;/&quot; , body ) |&gt; put_hmac ( body , @secret ) |&gt; cache_and_read_body ( ) iex&gt; HmacPlug . call ( conn , opts ( ) ) ** (PhoenixApiToolkit.Security.HmacVerificationError) HMAC invalid: method mismatch iex&gt; body = create_hmac_plug_body ( &quot;/&quot; , &quot;POST&quot; , %{ hello : &quot;world&quot; } , 12345 ) iex&gt; { :ok , _raw_body , conn } = conn_for_hmac ( :post , &quot;/&quot; , body ) |&gt; put_hmac ( body , @secret ) |&gt; cache_and_read_body ( ) iex&gt; HmacPlug . call ( conn , opts ( ) ) ** (PhoenixApiToolkit.Security.HmacVerificationError) HMAC invalid: expired","ref":"PhoenixApiToolkit.Security.HmacPlug.html","title":"PhoenixApiToolkit.Security.HmacPlug","type":"module"},{"doc":"Plug to verify an Oauth2 JWT. The JWT must be passed to the application in the authorization request header prefixed with Bearer: . The Plug must be configured with a set of JSON Web Keys used to sign the JWT's, a whitelist of algorithms that may be used to sign the JWT and the expected issuer. The optional dummy_verify setting can be used to skip JWT verification for development and testing. Requires :jose dependency in your mix.exs file. The most important setting is keyset , in which a base64-encoded JSON list of JWK's must be provided. In order to make the parsing work reliably, do the encoding in IEx or use echo 'keylist' | base64 in bash. This plug verifies the token's signature, issuer and expiration timestamp. Depending on the Oauth2 provider used, additional token claims should be verified. According to the Oauth2 spec, the &quot;aud&quot; claim must always be verified, for example. In practice, however, not all Oauth2 implementations adhere to the specification by including this claim in their tokens, so that's why verification of &quot;aud&quot; and other claims is not handled by default by this plug. Please refer to your Oauth2 provider's instructions about verifying token claims and take a look at PhoenixApiToolkit.Security.Plugs for additional claim verification plugs. If the token is invalid for any reason, PhoenixApiToolkit.Security.Oauth2TokenVerificationError is raised, resulting in a 401 Unauthorized response. Usage example plug Elixir.PhoenixApiToolkit.Security.Oauth2Plug , keyset : &quot;W3siYWxnIjoiUlMyNTYiLCJlIjoiQ&quot; , exp_iss : &quot;https://my_oauth2_auth_server&quot; , dummy_verify : false , alg_whitelist : [ &quot;RS256&quot; ] Results examples use Plug.Test import PhoenixApiToolkit.TestHelpers alias PhoenixApiToolkit.Security.Oauth2Plug @jwt_defaults %{ jwk : gen_jwk ( ) , jws : gen_jws ( ) , payload : gen_payload ( iss : &quot;http://my-oauth2-provider&quot; ) } def opts do Oauth2Plug . init ( lazy_keyset : fn -&gt; test_jwks ( ) |&gt; Oauth2Plug . process_jwks ( ) end , lazy_exp_iss : fn -&gt; @jwt_defaults . payload [ &quot;iss&quot; ] end , dummy_verify : false , alg_whitelist : [ &quot;RS256&quot; ] ) end a correctly signed request is passed through , with the JWT &#39; s payload and JWS assigned iex&gt; conn = conn ( :get , &quot;/&quot; ) iex&gt; jwt = gen_jwt ( @jwt_defaults ) iex&gt; result = conn |&gt; put_jwt ( jwt ) |&gt; Oauth2Plug . call ( opts ( ) ) iex&gt; result == conn |&gt; put_jwt ( jwt ) |&gt; assign ( :jwt , result . assigns . jwt ) |&gt; assign ( :jws , result . assigns . jws ) |&gt; assign ( :raw_jwt , result . assigns . raw_jwt ) true # requests that are noncompliant result in an Oauth2TokenVerificationError iex&gt; conn ( :get , &quot;/&quot; ) |&gt; Oauth2Plug . call ( opts ( ) ) ** (PhoenixApiToolkit.Security.Oauth2TokenVerificationError) Oauth2 token invalid: missing authorization header iex&gt; conn ( :get , &quot;/&quot; ) |&gt; put_jwt ( &quot;invalid&quot; ) |&gt; Oauth2Plug . call ( opts ( ) ) ** (PhoenixApiToolkit.Security.Oauth2TokenVerificationError) Oauth2 token invalid: could not decode JWT","ref":"PhoenixApiToolkit.Security.Oauth2Plug.html","title":"PhoenixApiToolkit.Security.Oauth2Plug","type":"module"},{"doc":"Process a jwks string to pass to &amp;call/2 .","ref":"PhoenixApiToolkit.Security.Oauth2Plug.html#process_jwks/1","title":"PhoenixApiToolkit.Security.Oauth2Plug.process_jwks/1","type":"function"},{"doc":"Security-related plugs. Several of these plugs are based on recommendations for API's by the OWASP guidelines .","ref":"PhoenixApiToolkit.Security.Plugs.html","title":"PhoenixApiToolkit.Security.Plugs","type":"module"},{"doc":"Protect AJAX-requests / API endpoints (ONLY those requests, not HTML forms!) against CSRF-attacks by requiring header x-csrf-token to be set to any value. This defense relies on the same-origin policy (SOP) restriction that only JavaScript can be used to add a custom header, and only within its origin. https://cheatsheetseries.owasp.org/cheatsheets/Cross-Site_Request_Forgery_Prevention_Cheat_Sheet.html#use-of-custom-request-headers Examples / doctests # requests that don&#39;t (shouldn&#39;t) change server state pass through iex&gt; conn ( :get , &quot;/&quot; ) |&gt; ajax_csrf_protect ( ) |&gt; Map . get ( :halted ) false # state-changing requests with the header pass through iex&gt; conn ( :post , &quot;/&quot; ) |&gt; put_req_header ( &quot;x-csrf-token&quot; , &quot;anything&quot; ) |&gt; ajax_csrf_protect ( ) |&gt; Map . get ( :halted ) false # state-changing requests without the header are rejected iex&gt; conn ( :post , &quot;/&quot; ) |&gt; ajax_csrf_protect ( ) ** (PhoenixApiToolkit.Security.AjaxCSRFError) missing &#39;x-csrf-token&#39; header","ref":"PhoenixApiToolkit.Security.Plugs.html#ajax_csrf_protect/2","title":"PhoenixApiToolkit.Security.Plugs.ajax_csrf_protect/2","type":"function"},{"doc":"Adds security headers to the response as recommended for API's by OWASP. Sets &quot;x-frame-options&quot;: &quot;deny&quot; and &quot;x-content-type-options&quot;: &quot;nosniff&quot; . Examples use Plug.Test # it does what it says it does iex&gt; conn = conn ( :get , &quot;/&quot; ) iex&gt; put_security_headers ( conn ) . resp_headers -- conn . resp_headers [ { &quot;x-frame-options&quot; , &quot;deny&quot; } , { &quot;x-content-type-options&quot; , &quot;nosniff&quot; } ]","ref":"PhoenixApiToolkit.Security.Plugs.html#put_security_headers/2","title":"PhoenixApiToolkit.Security.Plugs.put_security_headers/2","type":"function"},{"doc":"Checks if the request's &quot;content-type&quot; header is present. Content matching is done by Plug.Parsers . The filter is only applied to methods which are expected to carry contents, to PUT , POST and PATCH methods, that is. Only one content-type header is allowed. A noncompliant request causes a PhoenixApiToolkit.Security.MissingContentTypeError to be raised, resulting in a 415 Unsupported Media Type response. Examples use Plug.Test # safe methods pass through iex&gt; conn = conn ( :get , &quot;/&quot; ) iex&gt; conn == require_content_type ( conn ) true # compliant unsafe methods (put, post and patch) pass through iex&gt; conn = conn ( :post , &quot;/&quot; ) |&gt; put_req_header ( &quot;content-type&quot; , &quot;application/json&quot; ) iex&gt; conn == require_content_type ( conn ) true # noncompliant unsafe methods cause a MissingContentTypeError to be raised iex&gt; conn ( :post , &quot;/&quot; ) |&gt; require_content_type ( ) ** (PhoenixApiToolkit.Security.MissingContentTypeError) missing &#39;content-type&#39; header","ref":"PhoenixApiToolkit.Security.Plugs.html#require_content_type/2","title":"PhoenixApiToolkit.Security.Plugs.require_content_type/2","type":"function"},{"doc":"Set conn.remote_ip to the value in header &quot;x-forwarded-for&quot; , if present. ## Examples use Plug.Test def conn_with_ip , do : conn ( :get , &quot;/&quot; ) |&gt; Map . put ( :remote_ip , { 127 , 0 , 0 , 12 } ) # by default, the value of `remote_ip` is left alone iex&gt; conn = conn_with_ip ( ) |&gt; set_forwarded_ip ( ) iex&gt; conn . remote_ip { 127 , 0 , 0 , 12 } # if header &quot;x-forwarded-for&quot; is set, remote ip is overwritten iex&gt; conn = conn_with_ip ( ) |&gt; put_req_header ( &quot;x-forwarded-for&quot; , &quot;10.0.0.1&quot; ) |&gt; set_forwarded_ip ( ) iex&gt; conn . remote_ip { 10 , 0 , 0 , 1 }","ref":"PhoenixApiToolkit.Security.Plugs.html#set_forwarded_ip/2","title":"PhoenixApiToolkit.Security.Plugs.set_forwarded_ip/2","type":"function"},{"doc":"Check if the JWT in conn.assigns.jwt has an &quot;aud&quot; claim that matches the exp_aud parameter. This assign is set by PhoenixApiToolkit.Security.Oauth2Plug and should contain a JOSE.JWT struct. If not, a PhoenixApiToolkit.Security.Oauth2TokenVerificationError is raised, resulting in a 401 Unauthorized response. Examples use Plug.Test def conn_with_aud ( aud ) , do : conn ( :get , &quot;/&quot; ) |&gt; assign ( :jwt , %{ fields : %{ &quot;aud&quot; , aud } } ) # if aud matches, the conn is passed through iex&gt; conn = conn_with_aud ( &quot;my resource server&quot; ) iex&gt; conn == conn |&gt; verify_oauth2_aud ( &quot;my resource server&quot; ) true # an error is raised if aud does not match iex&gt; conn_with_aud ( &quot;my resource server&quot; ) |&gt; verify_oauth2_aud ( &quot;another server&quot; ) ** (PhoenixApiToolkit.Security.Oauth2TokenVerificationError) Oauth2 token invalid: aud mismatch","ref":"PhoenixApiToolkit.Security.Plugs.html#verify_oauth2_aud/2","title":"PhoenixApiToolkit.Security.Plugs.verify_oauth2_aud/2","type":"function"},{"doc":"Check if the JWT in conn.assigns.jwt has a &quot;scope&quot; claim that matches the exp_scopes parameter. This assign is set by PhoenixApiToolkit.Security.Oauth2Plug and should contain a JOSE.JWT struct. If not, a PhoenixApiToolkit.Security.Oauth2TokenVerificationError is raised, resulting in a 401 Unauthorized response. Examples use Plug.Test def conn_with_scope ( scope ) , do : conn ( :get , &quot;/&quot; ) |&gt; assign ( :jwt , %{ fields : %{ &quot;scope&quot; , scope } } ) # if there is a matching scope, the conn is passed through iex&gt; conn = conn_with_scope ( &quot;admin read:phone&quot; ) iex&gt; conn == conn |&gt; verify_oauth2_scope ( [ &quot;admin&quot; ] ) true iex&gt; conn == conn |&gt; verify_oauth2_scope ( [ &quot;admin&quot; , &quot;not:a:match&quot; ] ) true iex&gt; conn == conn |&gt; verify_oauth2_scope ( [ &quot;admin&quot; , &quot;read:phone&quot; ] ) true # an error is raised if there is no matching scope iex&gt; conn_with_scope ( &quot;admin read:phone&quot; ) |&gt; verify_oauth2_scope ( [ &quot;not:a:match&quot; ] ) ** (PhoenixApiToolkit.Security.Oauth2TokenVerificationError) Oauth2 token invalid: scope mismatch","ref":"PhoenixApiToolkit.Security.Plugs.html#verify_oauth2_scope/2","title":"PhoenixApiToolkit.Security.Plugs.verify_oauth2_scope/2","type":"function"},{"doc":"Various helper functions for writing tests.","ref":"PhoenixApiToolkit.TestHelpers.html","title":"PhoenixApiToolkit.TestHelpers","type":"module"},{"doc":"Put request header &quot;content-type: application/json&quot; on the conn. Examples use Plug.Test iex&gt; conn ( :post , &quot;/&quot; ) |&gt; application_json ( ) |&gt; get_req_header ( &quot;content-type&quot; ) [ &quot;application/json&quot; ]","ref":"PhoenixApiToolkit.TestHelpers.html#application_json/1","title":"PhoenixApiToolkit.TestHelpers.application_json/1","type":"function"},{"doc":"Remove volatile fields from maps in the data. Volatile fields like &quot;id&quot; mess up test comparisons. Recursively cleans maps and lists. Examples iex&gt; my_data = [ ...&gt; %{ ...&gt; &quot;updated_at&quot; =&gt; 12345 ...&gt; } , ...&gt; %{ ...&gt; &quot;some_thing&quot; =&gt; [ ...&gt; %{ ...&gt; &quot;id&quot; =&gt; 1 ...&gt; } , ...&gt; 12345 ...&gt; ] ...&gt; } ...&gt; ] iex&gt; clean_volatile_fields ( my_data ) [ %{ } , %{ &quot;some_thing&quot; =&gt; [ %{ } , 12345 ] } ]","ref":"PhoenixApiToolkit.TestHelpers.html#clean_volatile_fields/1","title":"PhoenixApiToolkit.TestHelpers.clean_volatile_fields/1","type":"function"},{"doc":"Generate a request body for an endpoint secured with PhoenixApiToolkit.Security.HmacPlug . Use put_hmac/3 to generate a valid signature. It is possible to override the timestamp set in the request body. The default generates a valid request body, so overrides are not necessary unless you wish to test the HMAC verification itself. Examples iex&gt; create_hmac_plug_body ( &quot;/hello&quot; , &quot;GET&quot; , %{ hello : &quot;world&quot; } , 12345 ) |&gt; Jason . decode! ( ) %{ &quot;contents&quot; =&gt; %{ &quot;hello&quot; =&gt; &quot;world&quot; } , &quot;method&quot; =&gt; &quot;GET&quot; , &quot;path&quot; =&gt; &quot;/hello&quot; , &quot;timestamp&quot; =&gt; 12345 }","ref":"PhoenixApiToolkit.TestHelpers.html#create_hmac_plug_body/4","title":"PhoenixApiToolkit.TestHelpers.create_hmac_plug_body/4","type":"function"},{"doc":"Generate a JSON Web Key for testing purposes. See gen_jwt/2 for details. The default is the first key of test_jwks/0 . Examples iex&gt; gen_jwk ( ) [ &quot;kid&quot; ] &quot;my_test_key&quot; iex&gt; gen_jwk ( kid : &quot;other key&quot; ) [ &quot;kid&quot; ] &quot;other key&quot;","ref":"PhoenixApiToolkit.TestHelpers.html#gen_jwk/1","title":"PhoenixApiToolkit.TestHelpers.gen_jwk/1","type":"function"},{"doc":"Generate a JSON Web Signature for testing purposes. See gen_jwt/2 for details. The defaults are the &quot;alg&quot; and &quot;kid&quot; values of the first key of test_jwks/0 . Examples iex&gt; gen_jws() %{&quot;alg&quot; =&gt; &quot;RS256&quot;, &quot;kid&quot; =&gt; &quot;my_test_key&quot;} iex&gt; gen_jws(alg: &quot;RS512&quot;)[&quot;alg&quot;] &quot;RS512&quot;","ref":"PhoenixApiToolkit.TestHelpers.html#gen_jws/1","title":"PhoenixApiToolkit.TestHelpers.gen_jws/1","type":"function"},{"doc":"Generate a JSON Web Token for testing purposes, with an &quot;exp&quot; claim 5 minutes in the future. It is possible to override parts of the signing key, payload and signature to test with different scopes, expiration times, issuers, key ID's etc, override the entire signing key, payload or signature. The defaults should generate a valid JWT. For use with endpoints secured with PhoenixApiToolkit.Security.Oauth2Plug . Examples @jwt_defaults %{ jwk : gen_jwk ( ) , jws : gen_jws ( ) , payload : gen_payload ( iss : &quot;http://my-oauth2-provider&quot; ) } # the defaults as created above generate a valid JWT, provided that the claims match those verified # the header, payload and signature can be inspected using JOSE.JWS.peek* functions iex&gt; jwt = gen_jwt ( @jwt_defaults ) iex&gt; jwt |&gt; JOSE.JWS . peek_protected ( ) |&gt; Jason . decode! ( ) %{ &quot;alg&quot; =&gt; &quot;RS256&quot; , &quot;kid&quot; =&gt; &quot;my_test_key&quot; , &quot;typ&quot; =&gt; &quot;JWT&quot; } iex&gt; jwt |&gt; JOSE.JWS . peek_payload ( ) |&gt; Jason . decode! ( ) |&gt; Map . drop ( [ &quot;exp&quot; ] ) %{ &quot;iss&quot; =&gt; &quot;http://my-oauth2-provider&quot; } # parts of the jwk, payload and jws can be overridden for testing purposes iex&gt; gen_jwt ( @jwt_defaults , payload : [ iss : &quot;boom&quot; ] ) |&gt; JOSE.JWS . peek_payload ( ) |&gt; Jason . decode! ( ) |&gt; Map . drop ( [ &quot;exp&quot; ] ) %{ &quot;iss&quot; =&gt; &quot;boom&quot; } iex&gt; gen_jwt ( @jwt_defaults , jws : [ kid : &quot;other key&quot; ] ) |&gt; JOSE.JWS . peek_protected ( ) |&gt; Jason . decode! ( ) %{ &quot;alg&quot; =&gt; &quot;RS256&quot; , &quot;kid&quot; =&gt; &quot;other key&quot; , &quot;typ&quot; =&gt; &quot;JWT&quot; } iex&gt; gen_jwt ( @jwt_defaults , payload : [ exp : 12345 ] ) |&gt; JOSE.JWS . peek_payload ( ) |&gt; Jason . decode! ( ) |&gt; Map . get ( &quot;exp&quot; ) 12345","ref":"PhoenixApiToolkit.TestHelpers.html#gen_jwt/2","title":"PhoenixApiToolkit.TestHelpers.gen_jwt/2","type":"function"},{"doc":"Generate a JSON Web Token payload for testing purposes. See gen_jwt/2 for details. The default payload is empty. Examples iex&gt; gen_payload ( ) %{ } iex&gt; gen_payload ( iss : &quot;something&quot; ) [ &quot;iss&quot; ] &quot;something&quot;","ref":"PhoenixApiToolkit.TestHelpers.html#gen_payload/1","title":"PhoenixApiToolkit.TestHelpers.gen_payload/1","type":"function"},{"doc":"Sets the request header &quot;x-csrf-token&quot;, to comply with PhoenixApiToolkit.Security.Plugs.ajax_csrf_protect() Examples / doctests iex&gt; conn ( :post , &quot;/&quot; ) |&gt; put_ajax_csrf_header ( ) |&gt; Map . get ( :req_headers ) [ { &quot;x-csrf-token&quot; , &quot;anything&quot; } ]","ref":"PhoenixApiToolkit.TestHelpers.html#put_ajax_csrf_header/1","title":"PhoenixApiToolkit.TestHelpers.put_ajax_csrf_header/1","type":"function"},{"doc":"Adds a HMAC-SHA256 signature to the connection's authorization header for the request body. Use create_hmac_plug_body/4 to generate a valid body. For use with endpoints secured with PhoenixApiToolkit.Security.HmacPlug . It is possible to override the HMAC secret. The default generates a valid signature, so overrides are not necessary unless you wish to test the HMAC verification itself. Examples use Plug.Test iex&gt; body = %{ greeting : &quot;world&quot; } |&gt; Jason . encode! ( ) iex&gt; conn = conn ( :post , &quot;/hello&quot; , body ) iex&gt; put_hmac ( conn , body , &quot;supersecretkey&quot; ) |&gt; get_req_header ( &quot;authorization&quot; ) [ &quot;oseq9TrQc/cyOBU7ujrkKM07tFewcVoaLRK0MgslSos=&quot; ]","ref":"PhoenixApiToolkit.TestHelpers.html#put_hmac/3","title":"PhoenixApiToolkit.TestHelpers.put_hmac/3","type":"function"},{"doc":"Add JWT to the conn. A valid, signed JWT can be generated by gen_jwt/2 . Examples use Plug.Test iex&gt; conn ( :get , &quot;/&quot; ) |&gt; put_jwt ( &quot;my_jwt&quot; ) |&gt; get_req_header ( &quot;authorization&quot; ) [ &quot;Bearer: my_jwt&quot; ]","ref":"PhoenixApiToolkit.TestHelpers.html#put_jwt/2","title":"PhoenixApiToolkit.TestHelpers.put_jwt/2","type":"function"},{"doc":"Put a whole map (or keyword list) of query params on a %Conn{} . Examples use Plug.Test iex&gt; conn ( :get , &quot;/&quot; ) |&gt; put_query_params ( user : &quot;Peter&quot; ) |&gt; Map . get ( :query_params ) %{ user : &quot;Peter&quot; }","ref":"PhoenixApiToolkit.TestHelpers.html#put_query_params/2","title":"PhoenixApiToolkit.TestHelpers.put_query_params/2","type":"function"},{"doc":"Put a raw request body in conn.assigns.raw_body for testing purposes. Examples use Plug.Test iex&gt; body = %{ hello : &quot;world&quot; } iex&gt; raw_body = body |&gt; Jason . encode! ( ) iex&gt; conn = conn ( :post , &quot;/&quot; ) |&gt; put_raw_body ( raw_body ) iex&gt; conn . adapter |&gt; elem ( 1 ) |&gt; Map . get ( :req_body ) |&gt; Jason . decode! ( ) %{ &quot;hello&quot; =&gt; &quot;world&quot; }","ref":"PhoenixApiToolkit.TestHelpers.html#put_raw_body/2","title":"PhoenixApiToolkit.TestHelpers.put_raw_body/2","type":"function"},{"doc":"Returns an example jwks for use by gen_jwt/2 , as base64-encoded JSON. Examples # the keyset is returned as base64-encoded JSON string with a list of keys iex&gt; test_jwks ( ) |&gt; Base . decode64! ( ) |&gt; Jason . decode! ( ) |&gt; List . first ( ) |&gt; Map . get ( &quot;kid&quot; ) &quot;my_test_key&quot;","ref":"PhoenixApiToolkit.TestHelpers.html#test_jwks/0","title":"PhoenixApiToolkit.TestHelpers.test_jwks/0","type":"function"},{"doc":"Converts a map with atoms in it as keys or values to a map with just strings. Works on nested maps as well. Examples iex&gt; %{ first_name : &quot;Peter&quot; , stuff : %{ &quot;things&quot; =&gt; :indeed } } |&gt; to_string_map ( ) %{ &quot;first_name&quot; =&gt; &quot;Peter&quot; , &quot;stuff&quot; =&gt; %{ &quot;things&quot; =&gt; &quot;indeed&quot; } }","ref":"PhoenixApiToolkit.TestHelpers.html#to_string_map/1","title":"PhoenixApiToolkit.TestHelpers.to_string_map/1","type":"function"},{"doc":"Defaults for use by gen_jwt/2","ref":"PhoenixApiToolkit.TestHelpers.html#t:gen_jwt_defaults/0","title":"PhoenixApiToolkit.TestHelpers.gen_jwt_defaults/0","type":"type"},{"doc":"Options for use by gen_jwt/2","ref":"PhoenixApiToolkit.TestHelpers.html#t:gen_jwt_opts/0","title":"PhoenixApiToolkit.TestHelpers.gen_jwt_opts/0","type":"type"},{"doc":"Error raised when a state-changing request does not have a &quot;x-csrf-token&quot; header.","ref":"PhoenixApiToolkit.Security.AjaxCSRFError.html","title":"PhoenixApiToolkit.Security.AjaxCSRFError","type":"exception"},{"doc":"Error raised the HMAC used to sign a request body is invalid","ref":"PhoenixApiToolkit.Security.HmacVerificationError.html","title":"PhoenixApiToolkit.Security.HmacVerificationError","type":"exception"},{"doc":"Error raised when a content-carrying request does not have a content-type header.","ref":"PhoenixApiToolkit.Security.MissingContentTypeError.html","title":"PhoenixApiToolkit.Security.MissingContentTypeError","type":"exception"},{"doc":"Error raised when an Oauth2 token is invalid","ref":"PhoenixApiToolkit.Security.Oauth2TokenVerificationError.html","title":"PhoenixApiToolkit.Security.Oauth2TokenVerificationError","type":"exception"},{"doc":"Phoenix API Toolkit The Phoenix API Toolkit consists of several modules designed to aid in the development of (mainly REST) API's with Elixir/Phoenix. While Phoenix and the ecosystem on which it depends ( Ecto and Plug ) provide much out of the box, you will find yourself writing some repetitive code when creating a flexible API. This library aims to reduce that repetition. The functionality in this library mainly grew out of our experience developing REST (or so-called-REST) API's and the possibly differing requirements of GraphQL API's were not taken into account. That being said, the functionality offered is usually quite generic, and can be useful in developing such an API as well.","ref":"readme.html","title":"Phoenix API Toolkit","type":"extras"},{"doc":"Imagine an index endpoint that supports filtering, searching, ordering and pagination, so that this HTTP call is possible, for example: GET /api/users?username=pete*&amp;order_by=asc:last_name&amp;birthday_before=2010-05-20&amp;limit=20 To support filtering based on Ecto model fields, you would soon find yourself writing a lot of queries like these: defmodule User do def by_first_name ( query , first_name ) do from [ user : user ] in query , where : user . first_name == ^ first_name end def by_birthday_before ( query , date ) do from [ user : user ] in query , where : user . birthday &lt; ^ date end end When taking into account that many fields like date fields and number fields logically benefit from smaller-than / greater-than filtering in addition to equal_to matching, the number of subqueries needed in the Ecto models and the complexity of the functions in the model context needed to support such functionality accross the API explodes. Dynamic filters It is possible to create a list-function in the context of the model. This function can become quite complicated / verbose as well. For example: defmodule UserContext do def list ( filters \\\\ %{ } ) do base_query = from ( user in &quot;users&quot; as : :user ) Enum . reduce ( filters , base_query , fn filter , query -&gt; { :first_name , value } -&gt; where ( [ user : user ] , user . first_name == ^ value ) { :birthday_before , value } -&gt; where ( [ user : user ] , user . birthday &lt; ^ value ) { :order_by , value } -&gt; order_by ( query , [ user : user ] , ^ value ) _ -&gt; query end ) end end Etc etc. For a model with 10 fields and order by / smaller than / greater than variants for each, a lot of code is required to support it all, with great potential for typing errors. Testing it all will grow tedious quickly. To solve this issue, standard filters can be applied using the PhoenixApiToolkit.Ecto.DynamicFilters.standard_filters/4 macro, which can be conveniently combined with PhoenixApiToolkit.Ecto.DynamicFilters.apply_filters/3 to get a nice query pipe. It supports various filtering styles: among them are equal_to matches, set membership, smaller/greater than comparisons, ordering and pagination. Standard filters can be combined with non-standard custom filters. The supported filters must be configured at compile time. @filter_definitions [ equal_to : [ :first_name ] , smaller_than : [ birthday_before : :birthday ] ] # a custom filter function def by_group_name ( query , group_name ) do from ( [ user : user ] in query , join : group in assoc ( user , :group ) , as : :group , where : group . name == ^ group_name ) end @doc &quot;&quot;&quot; My awesome list function. You can filter it, you know! And we guarantee the docs are up-to-date! \#{ generate_filter_docs ( @filter_definitions , equal_to : [ :group_name ] ) } &quot;&quot;&quot; def list_with_standard_filters ( filters \\\\ %{ } ) do from ( user in &quot;users&quot; , as : :user ) |&gt; apply_filters ( filters , fn # Add custom filters first and fallback to standard filters { :group_name , value } , query -&gt; by_group_name ( query , value ) filter , query -&gt; standard_filters ( query , filter , :user , @filter_definitions ) end ) end It is difficult to keep such a flexible function and its documentation in sync. To aid in doing so, documentation for standard filters can be autogenerated using PhoenixApiToolkit.Ecto.DynamicFilters.generate_filter_docs/2 . In the example above, the equal_to-type filter :group_name is passed as an extra. The generate_filter_docs/2 call above will generate documentation for the function. See PhoenixApiToolkit.Ecto.DynamicFilters for more info.","ref":"readme.html#dynamic-ecto-query-filtering-and-generic-queries","title":"Phoenix API Toolkit - Dynamic Ecto query filtering and generic queries","type":"extras"},{"doc":"By validating HTTP requests, unexpected errors can be prevented and useful feedback returned to the client. Additionally, invalid or dangerous input can be caught early. Note that the PhoenixApiToolkit.Ecto.DynamicFilters.standard_filters/4 macro relies on atom keys in the filters. To prevent atom-creation leaks, input for such filters must be validated as well. Validating HTTP requests can be done simply by using Ecto.Changeset s. A generic request validator to use as a basis has been created in PhoenixApiToolkit.GenericRequestValidator . A detailed example can be seen in its hex doc.","ref":"readme.html#http-request-validation","title":"Phoenix API Toolkit - HTTP request validation","type":"extras"},{"doc":"Security is always a complex topic of seemingly infinite depth. In order to help developers to maintain proper standards and adapt good practices, the Open Web Application Security Project or OWASP provides guidelines and detailed advice on several aspects of security, from recommended token timeouts to HTTP request/response headers to database design best practices. There are guidelines for REST API security , and the security plugs in this library implement some of these guidelines. The Oauth2 plug PhoenixApiToolkit.Security.Oauth2Plug can verify Oauth2 access / ID tokens, so that your API can use an external Oauth2/OpenID Connect provider for authentication / authorization (like Auth0 or Keycloak). Requires :jose dependency in your mix.exs file. The HMAC plug PhoenixApiToolkit.Security.HmacPlug can verify HMAC-signed requests, ensuring that the request body was sent by a known entity and was not tampered with on-route. Useful for (private) API-to-API communication. The function plugs in PhoenixApiToolkit.Security.Plugs serve several purposes, like checking request headers, verifying additional JWT claims and setting default response headers.","ref":"readme.html#security-plugs","title":"Phoenix API Toolkit - Security plugs","type":"extras"},{"doc":"The API toolkit provides several test helpers in PhoenixApiToolkit.TestHelpers . These are mainly meant to aid in writing integration tests in Phoenix, especially for endpoints secured using the Oauth2 plug or the HMAC plug. The test helpers can generate valid tokens for requests during testing. Some additional utility functions are included as well.","ref":"readme.html#test-helpers","title":"Phoenix API Toolkit - Test helpers","type":"extras"},{"doc":"The package can be installed by adding phoenix_api_toolkit to your list of dependencies in mix.exs : def deps do [ { :phoenix_api_toolkit , &quot;~&gt; 1.6.0&quot; } ] end","ref":"readme.html#installation","title":"Phoenix API Toolkit - Installation","type":"extras"},{"doc":"Documentation is available on HexDocs","ref":"readme.html#documentation","title":"Phoenix API Toolkit - Documentation","type":"extras"}]